module   TIME_ASCII_BCD  (
  input   [7:0] ASCII_RX ,
  input         RESET_N,
  input         CLK ,
  input         LATCH,
  output reg  [63:0] CLOCK ,
  output  [7:0] SS,
  output  [7:0] MM,  
  output  [7:0] HH ,
  output reg    TR ,
  output  [55:0] CHAR,
  output   reg  [143:0] CH1  
); 

//=======================================================
//  REG/WIRE declarations
//=======================================================
  reg  [7:0]  BYTE   ; 
  //reg  [63:0] CLOCK ;
  reg  [7:0]  CM    ; 
  //reg  [143:0] CH1   ;	
  
//=======================================================
//  Structural coding
//=======================================================

  assign  SS = { CLOCK[11:8]  , CLOCK[3:0] } ; 
  assign  MM = { CLOCK[35:32] , CLOCK[27:24] } ; 
  assign  HH = { CLOCK[59:56] , CLOCK[51:48] } ; 
  assign  CHAR = {"+","W","R","I","T","E",":" }  ; 
//------    
 always @(negedge RESET_N  or  posedge  CLK )  
 if  ( !RESET_N ) begin 
      CH1   <=0;
      CLOCK <=0; 
		BYTE  <=0; 
		TR    <=0; 
 end 
 else begin
      
      if ( LATCH  ) begin 
			  CH1[143:0]<=  { CH1[135:0 ] , ASCII_RX[7:0] } ; 
			  if  ( CH1[143:88] == CHAR    )  begin  
					CLOCK[15:0] <=  CH1[15:0] ; 
				   TR <= 1 ; 
			  end 		 
					else  TR <= 0 ; 			
	  end  		
end


endmodule 
