
module  UART_RX_J(
input               CLK,
input               RST_N,
input               TICK,
input               RX,
output reg [7:0]    RX_DATA,
output reg [7:0]    oRX_DATA,
output    reg       RX_INT,
output reg [7:0]    CNT,
output reg [7:0]    ST,
  output     [7:0] SS,
  output     [7:0] MM,  
  output     [7:0] HH ,
output reg LATCH 

 		  );
		  
reg [10:0] M_ADDR   ;          
reg        M_WR    ;    
		  
		  
always @( negedge RST_N or posedge	CLK ) 	
if (!RST_N) begin 
         ST  <=30; 
         CNT <=0;
         RX_DATA  <=0; 
         M_ADDR   <=0;    
         M_WR     <=0;  
         LATCH   <=0;   
         oRX_DATA <=0; 
end 
else case ( ST )
0:begin  
  if (  TICK  && !RX )  begin CNT <=CNT+1  ;  ST<=1; end  
  end  
1:begin   if (  TICK  )  begin 
             if    ( CNT ==9 ) ST<=10 ;
             else begin 
				       CNT <=CNT+1 ;  
						 case ( CNT )
						 1: RX_DATA[0] <= RX ; 
						 2: RX_DATA[1] <= RX ; 
						 3: RX_DATA[2] <= RX ; 
						 4: RX_DATA[3] <= RX ; 
						 5: RX_DATA[4] <= RX ; 
						 6: RX_DATA[5] <= RX ; 
						 7: RX_DATA[6] <= RX ; 
						 8: RX_DATA[7] <= RX ; 
                   endcase 
						end   
         end   
  end 
10:begin if ( !RX )   ST<= 12 ; 
        else begin ST<= 20  ;  CNT<=0; oRX_DATA <= RX_DATA ; end 
        end   
12:begin ST<=12; end

//--READ RAM     
20:begin ST<=21;  M_WR <= 1 ; LATCH<=0 ;  end
21:begin ST<=22;  M_WR <= 0 ; LATCH<=1 ; end
22:begin ST<=23;  M_ADDR <= M_ADDR+1 ; LATCH<=0 ; end
23:begin ST<=0; end

//---CLEAR VIEW RAM --- 
30:begin ST<=31;   M_WR <= 0 ;  oRX_DATA<=0;  end
31:begin ST<=32;   M_WR <= 1 ;   end
32:begin ST<=33;   M_WR <= 0 ;   end
33:begin ST<=34;   M_ADDR <= M_ADDR+1 ; end
34:begin    if ( M_ADDR==0) ST<=0; else ST<=31; end
endcase 
 
	wire  [7:0]  data;	
	wire  rdclk;
	reg   rdreq;

	wire	[7:0]  q;
	wire	       rdempty;
	wire	[7:0]  rdusedw;
	wire	[7:0]  wrusedw;
	
 
UART_FIFO UART_FIFO_i(
	.aclr    (~RST_N ),
	.data    (oRX_DATA),	
	.wrclk   (CLK ),
	.wrreq   (LATCH ),	
	.wrfull  (),
	.wrusedw (wrusedw),	
	.rdclk   ( CLK ),
	.rdreq   ( ),
	.q       ( ),
	.rdempty (rdempty),
	.rdusedw (),
	);

 
TIME_ASCII_BCD  tb(
  .ASCII_RX(oRX_DATA),
  .RESET_N (RST_N ),
  .CLK     (CLK     ),
  .LATCH   (LATCH   ),
  .SS      (SS     ),
  .MM      (MM     ),  
  .HH      (HH     )
);		  
	
	
////---RAM----  	

RAM_2K KK(
	.address( M_ADDR     ),
	.clock  ( CLK        ),
	.data   ( oRX_DATA   ),
	.wren   ( M_WR       ),
	.q      ( )
	);	


	

endmodule 		  
		  
 
 