
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_LITE_Golden_Top(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// VGA //////////
	output		     [3:0]		VGA_B,
	output		     [3:0]		VGA_G,
	output		          		VGA_HS,
	output		     [3:0]		VGA_R,
	output		          		VGA_VS,

	//////////// Accelerometer //////////
	output		          		GSENSOR_CS_N,
	input 		     [2:1]		GSENSOR_INT,
	output		          		GSENSOR_SCLK,
	inout 		          		GSENSOR_SDI,
	inout 		          		GSENSOR_SDO,

	//////////// Arduino //////////
	inout 		    [15:0]		ARDUINO_IO,
	inout 		          		ARDUINO_RESET_N,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	//inout 		    [35:0]		GPIO

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);



//=======================================================
//  REG/WIRE declarations
//=======================================================




//=======================================================
//  Structural coding
//=======================================================


assign MPU_CS_n = 1'b1;
assign MPU_FSYNC = 1'b0;
assign MPU_AD0_SDO = 1'b0;
	

    nios_qsys u0 (
        .clk_clk                                   (MAX10_CLK1_50),                                   //                                clk.clk
        .reset_reset_n                             (1'b1),                             //                              reset.reset_n
        .mpu_int_external_connection_export        (MPU_INT),        //        mpu_int_external_connection.export      
		  .mpu_i2c_opencores_export_scl_pad_io       (MPU_SCL_SCLK),       //           mpu_i2c_opencores_export.scl_pad_io
        .mpu_i2c_opencores_export_sda_pad_io       (MPU_SDA_SDI),       //                                   .sda_pad_io
		  
		  .light_int_external_connection_export      (LSENSOR_INT),      //      light_int_external_connection.export
        .light_i2c_opencores_export_scl_pad_io     (LSENSOR_SCL),     //         light_i2c_opencores_export.scl_pad_io
        .light_i2c_opencores_export_sda_pad_io     (LSENSOR_SDA),     //                                   .sda_pad_io
		  
		  .rh_temp_drdy_n_external_connection_export (RH_TEMP_DRDY_n), // rh_temp_drdy_n_external_connection.export
        .rh_temp_i2c_opencores_export_scl_pad_io   (RH_TEMP_I2C_SCL),   //       rh_temp_i2c_opencores_export.scl_pad_io
        .rh_temp_i2c_opencores_export_sda_pad_io   (RH_TEMP_I2C_SDA)    //                                   .sda_pad_io
    );
	 
	 


endmodule
