
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_LITE_Golden_Top(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// VGA //////////
	output		     [3:0]		VGA_B,
	output		     [3:0]		VGA_G,
	output		          		VGA_HS,
	output		     [3:0]		VGA_R,
	output		          		VGA_VS,

	//////////// Accelerometer //////////
	output		          		GSENSOR_CS_N,
	input 		     [2:1]		GSENSOR_INT,
	output		          		GSENSOR_SCLK,
	inout 		          		GSENSOR_SDI,
	inout 		          		GSENSOR_SDO,

	//////////// Arduino //////////
	inout 		    [15:0]		ARDUINO_IO,
	inout 		          		ARDUINO_RESET_N,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	//inout 		    [35:0]		GPIO

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);



//=======================================================
//  REG/WIRE declarations
//======================================================
   wire       RESET_N ; 
   wire [7:0] BCD_T , BCD_H;  
   wire [7:0] INT_FLAG	 ; 
   
   wire [15:0] DATA0  ; //Ambient Light Sensor DATA ,Channel 0
   wire [15:0] DATA1  ; //Ambient Light Sensor DATA ,Channel 1
   wire [15:0] PS_DATA ;// Proximity Sensor DATA,	
   wire [15:0] IR_DATA ;//	IR sensor data
	
   wire        HM_TR ;
	wire [15:0] HM_XOUT;
	wire [15:0] HM_YOUT;
	wire [15:0] HM_ZOUT;	
 	wire [15:0] ACCEL_XOUT;
	wire [15:0] ACCEL_YOUT;
	wire [15:0] ACCEL_ZOUT;
	wire [15:0] TEMP_OUT;
	wire [15:0] GYRO_XOUT;
	wire [15:0] GYRO_YOUT;
	wire [15:0] GYRO_ZOUT;
	wire [7:0 ] INT_STATUS;  
//=======================================================
//  Structural coding
//=======================================================


//---- RESET ---
assign RESET_N =KEY[0];
//----Humidity -Temperature SENSOR ---	
HC1000 HC1000_i(
      .RESET_N        (RESET_N        ),
      .CLOCK_50       (MAX10_CLK1_50  ),
      .RH_TEMP_DRDY_n (RH_TEMP_DRDY_n ),
      .RH_TEMP_I2C_SCL(RH_TEMP_I2C_SCL), 
      .RH_TEMP_I2C_SDA(RH_TEMP_I2C_SDA),
      .BCD_T          (BCD_T), 
      .BCD_H          (BCD_H)
);		
	
//----Ambient Light Sensor and Proximity Sensor ---	
APM_16D24 APM_16D24_i( 
   //--SYSTEM--   
	.RESET_N  (RESET_N),
   .CLK_50   (MAX10_CLK1_50),
	//--IC SIDE-- 
	.I2C_SCL  (LSENSOR_SCL),
	.I2C_SDA  (LSENSOR_SDA), 
	.CH0_DATA (DATA0 ),
	.CH1_DATA (DATA1 ),
	.PS_DATA  (PS_DATA),
	.IR_DATA  (IR_DATA),
   .INT_FLAG (INT_FLAG) 
	);


//---- RESET ---
	
assign MPU_AD0_SDO =0;//I2C Slave Address =0xD0
assign MPU_CS_n    =1; 
assign MPU_FSYNC   =0; 
//----9-Axis MEMS MotionTracking ---	
ICM20948  ICM20948_i( 
   //--SYSTEM-- 
	.RESET_N 	 ( RESET_N ),
   .CLK_50      ( MAX10_CLK1_50 ),
	//--IC SIDE--
	.RDY_n       ( MPU_INT),   
	.I2C_SCL     ( MPU_SCL_SCLK),
	.I2C_SDA     ( MPU_SDA_SDI ),
	.ACCEL_XOUT  (ACCEL_XOUT),
	.ACCEL_YOUT  (ACCEL_YOUT),
	.ACCEL_ZOUT  (ACCEL_ZOUT),
	.TEMP_OUT    (TEMP_OUT  ),
	.GYRO_XOUT   (GYRO_XOUT ),
	.GYRO_YOUT   (GYRO_YOUT ),
	.GYRO_ZOUT   (GYRO_ZOUT ),
	.INT_STATUS  (INT_STATUS ),
	.HM_XOUT     (HM_XOUT),
	.HM_YOUT     (HM_YOUT),
	.HM_ZOUT     (HM_ZOUT),
	.TR          (HM_TR) ,	
	
	);


//----------------4 HEX VIEW -------
//sw:0  HUMITY-TEMP       
//sw:1  Ambient LIGHT SENSOR ADC0 (DATA0)
//sw:2  Ambient LIGHT SENSOR ADC1 (DATA1)
//sw:3  Proximity Sensor DATA	
//sw:4  IR sensor DATA
//sw:5  THREE-AXIS MEMS ACCELEROMETER X
//sw:6  THREE-AXIS MEMS ACCELEROMETER Y
//sw:7  THREE-AXIS MEMS ACCELEROMETER Z
//sw:8  THREE-AXIS MEMS GYROSCOPE     X
//sw:9  THREE-AXIS MEMS GYROSCOPE     Y
//sw:10  THREE-AXIS MEMS GYROSCOPE     Z
//sw:11  THREE-AXIS MEMS MAGNETOMETER  X
//sw:12 THREE-AXIS MEMS MAGNETOMETER  Y
//sw:13 THREE-AXIS MEMS MAGNETOMETER  Z
//---------------------------------
//-----HEX SWITCHER ---- 
HEX_SWITCH  HEX_SWITCH_i(
   .SW        ( SW[3:0]), 
	.BCD_T     ( BCD_T  ),
   .BCD_H     ( BCD_H  ),
	.DATA0     ( DATA0  ),
	.DATA1     ( DATA1),
	.PS_DATA   ( PS_DATA ),
	.IR_DATA   ( IR_DATA ),
 	.ACCEL_XOUT( ACCEL_XOUT),
	.ACCEL_YOUT( ACCEL_YOUT),
	.ACCEL_ZOUT( ACCEL_ZOUT),
	.GYRO_XOUT ( GYRO_XOUT ),
	.GYRO_YOUT ( GYRO_YOUT ),
	.GYRO_ZOUT ( GYRO_ZOUT ),
	.HM_XOUT   ( HM_XOUT   ),
	.HM_YOUT   ( HM_YOUT   ),
	.HM_ZOUT   ( HM_ZOUT   ),	
	.RH_TEMP_DRDY_n(RH_TEMP_DRDY_n),
	.POR       ( INT_FLAG[7]), 
	.HM_TR     ( HM_TR   ), 
 	.HEX0      ( HEX0    ),
	.HEX1      ( HEX1    ),
	.HEX2      ( HEX2    ),
	.HEX3      ( HEX3    ),
	.HEX4      ( HEX4    ),
	.HEX5      ( HEX5    ),
	.HEX6      ( HEX6    ),
	.HEX7      ( HEX7    ),
	.LEDR      ( LEDR[2:0]    )
); 

//---50MHZ LED TEST
CLOCKMEM CLOCKMEM_i(  .CLK(MAX10_CLK1_50) ,.CLK_FREQ(50_000_000), .CK_1HZ (LEDR[9] ) ) ;

endmodule
