
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_LITE_Golden_Top(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// VGA //////////
	output		     [3:0]		VGA_B,
	output		     [3:0]		VGA_G,
	output		          		VGA_HS,
	output		     [3:0]		VGA_R,
	output		          		VGA_VS,

	//////////// Accelerometer //////////
	output		          		GSENSOR_CS_N,
	input 		     [2:1]		GSENSOR_INT,
	output		          		GSENSOR_SCLK,
	inout 		          		GSENSOR_SDI,
	inout 		          		GSENSOR_SDO,

	//////////// Arduino //////////
	inout 		    [15:0]		ARDUINO_IO,
	inout 		          		ARDUINO_RESET_N,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	//inout 		    [35:0]		GPIO

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);




parameter BAUD_BASE_FREQ    = 28_800_000 ; 
parameter BAUD_RATE         = 115200;//2400~230400

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire      RxD_data_ready ;
wire [7:0]RxD_data ; 
wire      CLK_28M8 ;
wire      locked ;
wire      TxD_data_ready ;
wire      check_ok ;
wire      SYSTEM_RST_n ; 

//=======================================================
//  Structural coding
//=======================================================

//--usrt control by pass
assign             UART_RTS = UART_CTS ;


//--baud rate base frequency generator
BAUD_PLL (
	.areset( 1'b0        ),
	.inclk0( MAX10_CLK1_50  ),
	.c0    ( CLK_28M8    ),
	.locked( locked      )
	
	);

	
// PC--->UART_RX---> UART_TX -->PC //
assign SYSTEM_RST_n =KEY[0] ;
//---uart rx 
UART_RX
  #(
   .ClkFrequency   (BAUD_BASE_FREQ      ), 
   .Baud           (BAUD_RATE           )  
   )
rx_1(
   .rst_n          (SYSTEM_RST_n  ),
   .clk            (CLK_28M8      ),
   .RxD            (UART_RX       ),
   .RxD_data_ready (RxD_data_ready), // is a hi-pulse when RxD_data is valid
   .RxD_data       (RxD_data)                                                          
);

//--RxD_data_ready-->TxD_data_ready
HANDSHAKE HANDSHAKE_i( 
 .rst_n     ( SYSTEM_RST_n  ),
 .CLK_50    ( CLK_28M8      ), 
 .data_ready( RxD_data_ready),
 .response  ( check_ok      ),
 .start     ( TxD_data_ready)
);


//--uart tx 
UART_TX 
  #(
   .ClkFrequency(BAUD_BASE_FREQ),
   .Baud        (BAUD_RATE          )  
   )
tx_1(
   .rst_n          (SYSTEM_RST_n  ),
   .clk            (CLK_28M8      ),
	.TX_check_ok    (check_ok      ),
   .TxD_start      (TxD_data_ready),
   .TxD_data       (RxD_data      ),
   .TxD            (UART_TX       ), 
   .TxD_busy       ()
);


//----LED Dispaly 
assign LEDR[0] = UART_RX ;
assign LEDR[1] = UART_TX ;
assign LEDR[2] = locked  ;

//----1HZ blink
CLOCKMEM ck( .RESET_n(1),  .CLK(CLK_28M8 ) , .CLK_FREQ(28_800_000) , .CK_1HZ(LEDR[3] ) ) ;



endmodule
