
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_LITE_Golden_Top(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// VGA //////////
	output		     [3:0]		VGA_B,
	output		     [3:0]		VGA_G,
	output		          		VGA_HS,
	output		     [3:0]		VGA_R,
	output		          		VGA_VS,

	//////////// Accelerometer //////////
	output		          		GSENSOR_CS_N,
	input 		     [2:1]		GSENSOR_INT,
	output		          		GSENSOR_SCLK,
	inout 		          		GSENSOR_SDI,
	inout 		          		GSENSOR_SDO,

	//////////// Arduino //////////
	inout 		    [15:0]		ARDUINO_IO,
	inout 		          		ARDUINO_RESET_N,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	//inout 		    [35:0]		GPIO

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire		      DLY_RST;
wire           DLY_EN ; 
wire [23:0]	   mSEG7_DIG;
wire           UART_RXD_TXD ; 
wire           ADDRESS  ;
wire           CS       ;
wire [3:0]     BYTE_ENABLE     ;
wire           READ     ;
wire           WRITE    ;
wire           IRQ      ;
wire [31:0]    WRITEDATA;
wire [31:0]    READDATA ;
wire           READY ;
wire           UART_RX_1 ; 
wire [7:0]     SS;
wire [7:0]     MM;
wire [7:0]     HH;
wire [7:0]     MESSAGE;
wire [159: 0 ] NAME; 
wire [159: 0 ] PASSWORD; 
wire [159: 0 ] oNAME; 
wire [159: 0 ] oPASSWORD; 
wire [7: 0 ]   NAME_LN     ;
wire [7: 0 ]   PASSWORD_LN ;

//=======================================================
//  Structural coding
//=======================================================

//---- ESP32-WROOM-32E initally
assign ESP32_UART1_RTS  = 0;
assign ESP32_EN         = (DLY_EN)?1'bz:1'b0; 
	
//---- RESET DELAY  ---	
Reset_Delay	 r0	(	
      .iRESET_N  ( KEY [0])  , 
		.iCLK      ( MAX10_CLK1_50 ),
		.oRESET1   ( DLY_EN   ),//1s				
		.oRESET2   ( DLY_RST  )	//3s			
);
//---- FROM ESP32-WROOM-32E RX  ---	
assign UART_RX_1  = READY ? ESP32_UART1_RX :1  ;

//--- NAME & PASSWORD    
assign NAME      = "" ; 
assign PASSWORD  = "";

//--- NAME & PASSWORD String Check  
 NAME_PASSWD  cf( 
   .CLK        ( MAX10_CLK1_50  ) ,
   .RESET_N    ( KEY [0]  ), 
   .NAME       ( NAME     ), 
   .PASSWORD   ( PASSWORD ),
   .NAME_LN    ( NAME_LN  ),
   .PASSWORD_LN( PASSWORD_LN ),
   .oNAME      ( oNAME     ),
   .oPASSWORD  ( oPASSWORD )
) ; 

//-- WIFI COMMAND SEQUENCE CONTROLLER -- 
UART_ST   st    (
   .CLK         (MAX10_CLK1_50 ),
	.NAME        ( oNAME       ) , 
   .PASSWORD    ( oPASSWORD),
   .NAME_LN     ( NAME_LN ), 
   .PASSWORD_LN ( PASSWORD_LN ),	
   .RX          ( UART_RX_1), 	
   .RESET_N     ( DLY_RST  ) ,

   //--UART IP BUS 
   .ADDRESS     ( ADDRESS  ) ,
   .CS          ( CS       ) ,
   .BYTE_ENABLE ( BYTE_ENABLE ),
   .READ        ( READ     ),
   .WRITE       ( WRITE    ),
   .WRITEDATA   ( WRITEDATA ),
   .READDATA    ( READDATA ),
	.READY       ( READY ) ,
	.MESSAGE     ( MESSAGE ),

	//----TO 7-SEG 
   .Second      ( SS ),
   .Minute      ( MM ),  
   .Hour        ( HH )
);

//----UART TX
UART_TX   UART_TX_i(
   .clk_50      (MAX10_CLK1_50),
   .reset_n     (DLY_RST & READY),
   .write       (WRITE),
   .chipselect  (CS),
   .writedata   (WRITEDATA),
   .tx          (ESP32_UART1_TX)
);

//---- ESP32-WROOM-32E UART RESPONSE WIFI CLOCK ---
assign	mSEG7_DIG	= {  HH , MM,  SS };

//----7 segment LUT ---
SEG7_LUT_6 			u0	(	.oSEG0(HEX0[6:0]),
							   .oSEG1(HEX1[6:0]),
							   .oSEG2(HEX2[6:0]),
							   .oSEG3(HEX3[6:0]),
								.oSEG4(HEX4[6:0]),
								.oSEG5(HEX5[6:0]),
							   .iDIG ( mSEG7_DIG ));	

//----SET 7 segment DOT ---								
assign 	HEX0[7]=1'b1 ;
assign 	HEX1[7]=1'b1 ;
assign 	HEX2[7]=1'b0 ;
assign 	HEX3[7]=1'b1 ;
assign 	HEX4[7]=1'b0 ;
assign 	HEX5[7]=1'b1 ;
//---- LED DISPLAY  ---
assign  LEDR[9:0]    = { READY ,ESP32_UART1_RX, ESP32_UART1_TX, 3'b00,  MESSAGE[3:0] } ;


endmodule
