
module RX_TIME_ASCII_BCD (
   input        CK_50 , 
   input        RST_N , 
   input        RX ,
   output [7:0] SS,
   output [7:0] MM,
   output [7:0] HH 
);



wire CK_28M8 ; 
wire TICK  ;  

BAUD_PLL dd(
	 .areset( ~RST_N   ),
	 .inclk0( CK_50   ),
	 .c0    ( CK_28M8 ),//115200*250 = 28.8MHz
	 .locked() 		
);

BAUD_GEN ff(
    .clk_i       ( CK_28M8),  
    .tr          ( RX ) , 
    .rst_i       ( RST_N    ), 
    .baud_tick   ( TICK     ), 
    .baud_freq_i ( 115200   ), 
    .baud_limit_i( 115200*250)
);

UART_RX_J rt(
 .CLK     ( CK_28M8 ),
 .RST_N   ( RST_N),
 .TICK    ( TICK),
 .RX      ( RX),
 .RX_DATA (),
 .RX_INT  (),
 .CNT     (),
 .ST      (),
 .SS      ( SS ),
 .MM      ( MM ),  
 .HH      ( HH ) 
);

endmodule 
