module   TIME_ASCII_BCD  (
  input   [7:0] ASCII_RX ,
  input         RESET_N,
  input         CLK ,
  input         LATCH,
  output  [7:0] SS,
  output  [7:0] MM,  
  output  [7:0] HH ,
  output reg    TR ,
  output [39:0] data,
  output reg [7:0]  BYTE,
  
  output reg [15:0]  rSS,
  output reg [15:0]  rMM,
  output reg [15:0]  rHH,
  output reg  [47:0] CH1  
  
  
  
); 

//=======================================================
//  REG/WIRE declarations
//=======================================================
    
//=======================================================
//  Structural coding
//=======================================================


  assign  SS = { rSS[11:8] , rSS[3:0] } ; 
  assign  MM = { rMM[11:8] , rMM[3:0] } ; 
  assign  HH = { rHH[11:8] , rHH[3:0] } ; 
  assign data = CH1[39:0]; 
//------    
 always @(negedge RESET_N  or  posedge  CLK )  
 if  ( !RESET_N ) begin 
      CH1   <=0;
		TR    <=0;
	   BYTE  <=0;	
		rHH   <=0; 
		rMM   <=0; 
		rSS   <=0;
		
 end 
 else begin
      
      if ( LATCH  ) begin 
			      CH1[47:0]<=  { CH1[46:0 ] , ASCII_RX } ; 
			      if   ( CH1[39:0] == {"D","a","t","e",":"}  )   begin  BYTE<=0;   TR <= 1; end 
					else if   ( CH1[23:0] == {"G","M","T"}  ) TR <= 0;
				   if  (TR)  BYTE <= BYTE+1;
					case (BYTE )
					19:  rHH <= CH1[15:0] ; 
					22:  rMM <= CH1[15:0] ; 
					25:  rSS <= CH1[15:0] ; 
					endcase
		   			
	  end  		
end


endmodule 
