
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module WiFi_Network_Time(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,  // ESP32 UART0 RX
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,  //ESP32 UART1 RX
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);



//=======================================================
//  REG/WIRE declarations
//=======================================================
wire pio_wifi_enable;

wire HEX0_DP, HEX1_DP, HEX2_DP, HEX3_DP, HEX4_DP, HEX5_DP;

//=======================================================
//  Structural coding
//=======================================================

assign ESP32_EN = pio_wifi_enable?1'bz:1'b0;


assign LEDR[8] = ~ESP32_UART1_TX;
assign LEDR[9] = ~ESP32_UART1_RX;

RFS_WiFi u0(
        .clk_clk(MAX10_CLK1_50),                                        //                                clk.clk
        .reset_reset_n(KEY[0]),                                         //                              reset.reset_n
        .pio_key_external_connection_export(KEY[1]),                    //            key_external_connection.export

        .wifi_uart_external_connection_rxd(ESP32_UART1_RX),             //     wifi_uart0_external_connection.rxd
        .wifi_uart_external_connection_txd(ESP32_UART1_TX),             //                                   .txd
        .wifi_uart_external_connection_cts_n(ESP32_UART1_CTS),          //                                   .cts_n
        .wifi_uart_external_connection_rts_n(ESP32_UART1_RTS),          //                                   .rts_n

        .seg7_if_conduit_end_export({HEX5, HEX4,
                                       HEX3, HEX2,
                                       HEX1, HEX0}),                    //              seg7_if_0_conduit_end.export

        .pio_wifi_enable_external_connection_export(pio_wifi_enable),     // pio_wifi_reset_external_connection.export
        .pio_led_external_connection_export(LEDR[3: 0])                 //        pio_led_external_connection.export
    );
	 
	 // connect RSP32 UART0 to on-board UART-to-USB
assign UART_TX = ESP32_UART0_RX; // ESP32_UART0_RX: ESP32 uart0 debug out
assign ESP32_UART0_TX = UART_RX; // ESP32_UART0_TX: ESP32 uart0 for firmare download
assign UART_RTS = UART_CTS;
	 

endmodule
