module UART_BLE  (
  input             NOTIFY,
  input             RX  , 

 
  input             CLK,
  input             RESET_N  ,
  output reg        WRITE,
  output reg [31:0] WRITEDATA ,
  output reg [63:0] DELAY , 

  output reg        READY  , 
  
  //
  output reg [7:0]  ST 	,
  output     [7:0]  WRCM1,
  output     [7:0]  WRCM2,
  output     [7:0]  WRCM3,
  output     [7:0]  WRCM4,
  output     [7:0]  WRCM5,  
  output     [7:0]  WRCM6,
  output     [7:0]  WRCM7,
  output     [7:0]  WRCM8,
  output     [7:0]  WRCM9,
  output     [7:0]  WRCM10,
  output     [7:0]  WRCM11,
  output     [7:0]  WRCM12,

  output reg [7:0]  CNT ,
  
  output reg [7:0]    RD_LENTH, 
  output reg [7:0]    MESSAGE,
  output reg [7:0]    WR_LEN ,
  output reg [15:0]   M_ADDR , 
  output reg          M_WR ,
  output     [7:0] SS,
  output     [7:0] MM,  
  output     [7:0] HH 
  
  
  
);

parameter  TIME_BASE     = 50000000 ;
parameter  S1= TIME_BASE  * 1; 
parameter  S2= TIME_BASE  * 2; 
parameter  S10= TIME_BASE * 10;

parameter  MASSEGE_LN_WR1  =15;
parameter  MASSEGE_LN_WR2  =14;
parameter  MASSEGE_LN_WR3  =19;
parameter  MASSEGE_LN_WR4  =21;
parameter  MASSEGE_LN_WR5  =27;
parameter  MASSEGE_LN_WR6  =52;
parameter  MASSEGE_LN_WR7  =16;
parameter  MASSEGE_LN_WR8  =24;
parameter  MASSEGE_LN_WR9  =11;
parameter  MASSEGE_LN_WR10 =16;
parameter  MASSEGE_LN_WR11 =3;
parameter  MASSEGE_LN_WR12 =2;

parameter  MASSEGE_NUM   =12;

//=======================================================
//  REG/WIRE declarations
//======================================================= 

//wire [7:0]   MASSEGE_LN_WR3; 

//=======================================================
//  Structural coding
//=======================================================
//---WIFI TIME READ HH:MM:SS  --
RX_TIME_ASCII_BCD  md(
   .CK_50  (CLK), 
   .RST_N  (READY), 
   .RX     (RX),
   .SS     (SS ),
   .MM     (MM ),
   .HH     (HH )
);
 

//------------st ------
always @(negedge RESET_N or posedge  CLK ) 
if ( !RESET_N) begin
  READY      <=0; 
  ST         <=0;    
  WRITE      <=0;  
  CNT        <=0;  
  WRITEDATA  <=32'h0;  
  DELAY      <=0; 
  MESSAGE    <=1; 
  M_ADDR     <=0;  
  M_WR       <=0;  
  
end
else begin 
  case (ST) 
  0:begin  
           if  (DELAY != S2 )  begin 
			      DELAY     <=DELAY+1 ; 
               M_ADDR    <=M_ADDR +1; 					
               M_WR      <=1; 
 			   end 
			   else  begin 
				  M_ADDR    <=0; 
				  M_WR      <=0; 	
				  ST        <=3;         				
				  READY     <=1; 
				  MESSAGE   <=1; 
			 end 
	end  
 
 //----- WRITE TO ESP8266 COMMAND 
 3:begin
 			  
                   if ( MESSAGE ==1 )  begin WR_LEN<= MASSEGE_LN_WR1; end
				  else if ( MESSAGE ==2 )  begin WR_LEN<= MASSEGE_LN_WR2; end
				  else if ( MESSAGE ==3 )  begin WR_LEN<= MASSEGE_LN_WR3; end
				  else if ( MESSAGE ==4 )  begin WR_LEN<= MASSEGE_LN_WR4; end
				  else if ( MESSAGE ==5 )  begin WR_LEN<= MASSEGE_LN_WR5; end
				  else if ( MESSAGE ==6 )  begin WR_LEN<= MASSEGE_LN_WR6; end
				  else if ( MESSAGE ==7 )  begin WR_LEN<= MASSEGE_LN_WR7; end
				  else if ( MESSAGE ==8 )  begin WR_LEN<= MASSEGE_LN_WR8; end
				  else if ( MESSAGE ==9 )  begin WR_LEN<= MASSEGE_LN_WR9; end
				  else if ( MESSAGE ==10 ) begin WR_LEN<= MASSEGE_LN_WR10; end
				  else if ( MESSAGE ==11 ) begin WR_LEN<= MASSEGE_LN_WR11; end
				  else if ( MESSAGE ==12 ) begin WR_LEN<= MASSEGE_LN_WR12; end
				    ST  <=4;  
				    CNT <=0 ; 
  end  
 
 4:begin  ST  <=5;   end  
				 
 5:begin 
          ST <=6; CNT <=CNT+1 ; 
          if ( MESSAGE ==1 )  begin  WRITEDATA <= WRCM1[7:0] ;   end			
	  else if ( MESSAGE ==2 )  begin  WRITEDATA <= WRCM2[7:0] ;   end			
	  else if ( MESSAGE ==3 )  begin  WRITEDATA <= WRCM3[7:0] ;   end			
	  else if ( MESSAGE ==4 )  begin  WRITEDATA <= WRCM4[7:0] ;   end			
	  else if ( MESSAGE ==5 )  begin  WRITEDATA <= WRCM5[7:0] ;   end			
	  else if ( MESSAGE ==6 )  begin  WRITEDATA <= WRCM6[7:0] ;   end							
	  else if ( MESSAGE ==7 )  begin  WRITEDATA <= WRCM7[7:0] ;   end							
	  else if ( MESSAGE ==8 )  begin  WRITEDATA <= WRCM8[7:0] ;   end							
	  else if ( MESSAGE ==9 )  begin  WRITEDATA <= WRCM9[7:0] ;   end							
	  else if ( MESSAGE ==10 ) begin  WRITEDATA <= WRCM10[7:0] ;   end							
	  else if ( MESSAGE ==11 ) begin  WRITEDATA <= WRCM11[7:0] ;   end							
	  else if ( MESSAGE ==12 ) begin  WRITEDATA <= WRCM12[7:0] ;   end							
	end 
	
6:begin ST <=7; WRITE <=1;  end 
7:begin ST <=8; WRITE <=0; end  	
	
8:begin  
	   M_ADDR <= M_ADDR+1; 
      if (   CNT != WR_LEN) begin 
	          ST<=5; 
		end 
	   else begin 
			  CNT    <=  0 ;
           ST     <=  9;
           DELAY  <=  0 ; 
			  M_WR   <=  0 ; 
		end 
   end  //-----END WRITE  ------- 
	
//---READ----
9:begin  
		     if (  
			     (( MESSAGE ==1 )  && (DELAY !=S1 )) || 
			     (( MESSAGE ==2 )  && (DELAY !=S2 )) || 
			     (( MESSAGE ==3 )  && (DELAY !=S1 )) || 
			     (( MESSAGE ==4 )  && (DELAY !=S1 )) || 
				  (( MESSAGE ==5 )  && (DELAY !=S1 )) || 
				  (( MESSAGE ==6 )  && (DELAY !=S1 )) || 
				  (( MESSAGE ==7 )  && (DELAY !=S1 )) || 
				  (( MESSAGE ==8 )  && (DELAY !=S1 )) || 
				  (( MESSAGE ==9 )  && (DELAY !=S1 )) || 
				  (( MESSAGE ==10 ) && (DELAY !=S1 )) || 
				  (( MESSAGE ==11 ) && (DELAY !=S1 )) || 
			     (( MESSAGE ==12 ) && (DELAY !=S1 ))    
				  )
           begin
					 DELAY <=DELAY+1 ; 
           end					 
           else begin 
                ST     <=10 ; 	
		          M_WR   <=1  ; 			 
           end 
 	end 
10:begin 
	 if ( MESSAGE == MASSEGE_NUM )  ST<= 11;
	 else begin  
	            if ( (( MESSAGE ==8 ) &&  (!NOTIFY)) || (MESSAGE !=8 ))  begin
					   MESSAGE<= MESSAGE+1 ;  
				      ST     <= 3; 
	               DELAY  <= 0; 
				      CNT    <= 0 ;
					end 
	 end 
end //---read end ---- //

11:begin  

	 begin 
	    	 ST      <=12; 
			 DELAY   <=0; 
	 end 	 
	 end 
//-----ST-END 	
12:begin  
     ST      <=3;
	  MESSAGE <=8 ;
	  CNT     <=0 ;
   end
 endcase   
end




//====== TX :SEND TO ESP32 BLE AT COMMAND ======
BLE_STEP1   stp1 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM1 ) );
BLE_STEP2   stp2 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM2 ) );
BLE_STEP3   stp3 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM3 ) );
BLE_STEP4   stp4 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM4 ) );
BLE_STEP5   stp5 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM5 ) );
BLE_STEP6   stp6 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM6 ) );
BLE_STEP7   stp7 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM7 ) );
BLE_STEP8   stp8 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM8 ) );
BLE_STEP9   stp9 ( .ADDRESS  ( CNT), .ROM_DATA ( WRCM9 ) );
BLE_STEP10  stp10( .ADDRESS  ( CNT), .ROM_DATA ( WRCM10) );
BLE_STEP11  stp11( .ADDRESS  ( CNT), .ROM_DATA ( WRCM11) );
BLE_STEP12  stp12( .ADDRESS  ( CNT), .ROM_DATA ( WRCM12) ); 

 
endmodule 
