module  UART_TX_J (
input       clk_50  ,
input       reset_n ,
input       write  ,
input [7:0] writedata ,
output  reg tx ,
output      tick,
output reg[7:0]tick_cnt , 
output reg[7:0] cnt,
output reg[7:0] st,
output reg[7:0] w_data,
output CK_28M8 ,
output reg srt 

);

   wire  aclr;
	wire  [7:0]  data;	
	wire  rdclk;
	reg   rdreq;
	wire  wrclk;
	wire  wrreq;
	wire	[7:0]  q;
	wire	       rdempty;
	wire	[7:0]  rdusedw;
	wire	       wrfull;
	wire	[7:0]  wrusedw;


assign aclr  = ~reset_n;	
assign wrclk = clk_50 ; //inportnat
assign wrreq = write ; 

 wire locked ; 
BAUD_PLL (
	.areset(1'b0),
	.inclk0(clk_50 ),
	.c0    (CK_28M8 ),
	.locked(locked)
	);
 
assign tick = (tick_cnt==0); 
always @(posedge CK_28M8 ) 
if  ( tick_cnt>= 249) begin tick_cnt<=0;  end  //249
else tick_cnt<=tick_cnt+1; 

always @( negedge reset_n  or posedge CK_28M8 ) begin 
if (!reset_n) begin
  st <=0;
  cnt<=10;
  //rdclk <=0; 
  rdreq <=0;
  tx <=1; 
end 
else case(st)
0:begin 
   st    <=10 ;
	//w_data<=data ; 
  end 	
1:begin 
  if(tick) begin 
    case(cnt)
	  10:begin tx <=0 ; srt <=1 ; end 
	   9:tx <=w_data[0] ;
	   8:tx <=w_data[1] ;
	   7:tx <=w_data[2] ;
	   6:tx <=w_data[3] ;
	   5:tx <=w_data[4] ;
	   4:tx <=w_data[5] ;
	   3:tx <=w_data[6] ;
	   2:tx <=w_data[7] ;
	   1:begin tx <=1 ; srt <=0 ; end 
	 endcase
	 if (cnt==1) st<=10 ; else cnt<=cnt-1 ; 
  end
  end 
//--check read
10:begin 
//if ( wrusedw !=0) 
if (!rdempty) 
st<=11;
end   

11:begin 
st<=12;
//rdreq <=1;
end   
12:begin 
st<=13;
rdreq <=1;
end   
13:begin 
st<=14;
rdreq <=0;
end   
14:begin 
st<=1;
//rdreq  <=0;
w_data <=q;
cnt    <=10;
end   


endcase 
end

// synopsys translate_on
wire   clr = ~locked | aclr ; 
assign rdclk = CK_28M8;//inportant 

UART_FIFO UART_FIFO_i(
	.aclr    (clr),
	.rdclk   (rdclk ),
	.rdreq   (rdreq ),
	.q       (q),
	.rdempty (rdempty),
	.rdusedw (),
	.data    (writedata),	
	.wrclk   (wrclk ),
	.wrreq   (wrreq ),	
	.wrfull  (),
	.wrusedw (wrusedw)
	);

endmodule 