#include "terasic_includes.h"

#ifndef LIGHT_SENSOR_H_
#define LIGHT_SENSOR_H_

#define DEVICE_ADDR     0x70 // 0x70 <<1
//#define DEVICE_ADDR     0x92

// REGISTER MAP
#define P_SYSM_CTRL    0x00// RW 0x00 ALS/PS operation mode control, waitingmode control, SW reset
#define P_INT_CTRL     0x01// RW 0x03 Interrupt pin control, interrupt persistcontrol
#define P_INT_FLAG     0x02// RW 0x00 Interrupt flag, error flag, power on reset(POR) flag
#define P_WAIT_TIME    0x03// RW 0x00 Waiting time setting
#define P_ALS_GAIN     0x04// RW 0x00 ALS analog gain setting
#define P_ALS_TIME     0x05// RW 0x00 ALS integrated time setting
#define P_LED_CTRL     0x06// RW 0x00 LED setting
#define P_PS_GAIN      0x07// RW 0x00 PS analog gain setting
#define P_PS_PULSE     0x08// RW 0x00 PS number of LED pulse
#define P_PS_TIME      0x09// RW 0x00 PS integrated time setting
#define P_PERSISTENCE  0x0B// RW 0x11 ALS/PS persistence setting
#define P_ALS_THRES_LL 0x0C// RW 0x00 ALS lower interrupt threshold - LSB
#define P_ALS_THRES_LH 0x0D// RW 0x00 ALS lower interrupt threshold - MSB
#define P_ALS_THRES_HL 0x0E// RW 0xFF ALS higher interrupt threshold - LSB
#define P_ALS_THRES_HH 0x0F// RW 0xFF ALS higher interrupt threshold - MSB
#define P_PS_THRES_LL  0x10// RW 0x00 PS lower interrupt threshold - LSB
#define P_PS_THRES_LH  0x11// RW 0x00 PS lower interrupt threshold - MSB
#define P_PS_THRES_HL  0x12// RW 0xFF PS higher interrupt threshold - LSB
#define P_PS_THRES_HH  0x13// RW 0xFF PS higher interrupt threshold - MSB
#define P_PS_OFFSET_L  0x14// RW 0x00 PS offset level - LSB
#define P_PS_OFFSET_H  0x15// RW 0x00 PS offset level - MSB
#define P_INT_SOURCE   0x16// RW 0x00 ALS interrupt source
#define P_ERROR_FLAG   0x17// RW 0x00 Error flag
#define P_PS_DATA_L    0x18// R 0x00 PS output data - LSB
#define P_PS_DATA_H    0x19// R 0x00 PS output data - MSB
#define P_IR_DATA_L    0x1A// R 0x00 IR output data - LSB
#define P_IR_DATA_H    0x1B// R 0x00 IR output data - MSB
#define P_CH0_DATA_L   0x1C// R 0x00 Channel 0 output data - LSB
#define P_CH0_DATA_H   0x1D// R 0x00 Channel 0 output data - MSB
#define P_CH1_DATA_L   0x1E// R 0x00 Channel 1 output data - LSB
#define P_CH1_DATA_H   0x1F// R 0x00 Channel 1 output data - MSB
#define P_PNO_LB       0xBC// R 0x14 Product number, Low Byte
#define P_PNO_HB       0xBD// R 0x16 Product number, High Byte


//public API
void Light_Init(alt_u32 I2C_Controller_Base); // init i2c ip core
bool Light_Setup();
bool Light_Get_ADCData0(alt_u16 *pChannelData);
bool Light_Get_ADCData1(alt_u16 *pChannelData);
bool Get_light(alt_u16 *light0, alt_u16 *light1);


#endif /*LIGHT_SENSOR_H_*/


