// ============================================================================
// Copyright (c) 2021 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Jul  7 15:11:40 2021
// ============================================================================

//`define ENABLE_HPS

module DE10_Nano_golden_top(

      ///////// ADC /////////
      output             ADC_CONVST,
      output             ADC_SCK,
      output             ADC_SDI,
      input              ADC_SDO,

      ///////// ARDUINO /////////
      inout       [15:0] ARDUINO_IO,
      inout              ARDUINO_RESET_N,

      ///////// FPGA /////////
      input              FPGA_CLK1_50,
      input              FPGA_CLK2_50,
      input              FPGA_CLK3_50,

      ///////// GPIO /////////
      //inout       [35:0] GPIO_0,
      inout       [35:0] GPIO_1,

      ///////// HDMI /////////
      inout              HDMI_I2C_SCL,
      inout              HDMI_I2C_SDA,
      inout              HDMI_I2S,
      inout              HDMI_LRCLK,
      inout              HDMI_MCLK,
      inout              HDMI_SCLK,
      output             HDMI_TX_CLK,
      output      [23:0] HDMI_TX_D,
      output             HDMI_TX_DE,
      output             HDMI_TX_HS,
      input              HDMI_TX_INT,
      output             HDMI_TX_VS,

`ifdef ENABLE_HPS
      ///////// HPS /////////
      inout              HPS_CONV_USB_N,
      output      [14:0] HPS_DDR3_ADDR,
      output      [2:0]  HPS_DDR3_BA,
      output             HPS_DDR3_CAS_N,
      output             HPS_DDR3_CKE,
      output             HPS_DDR3_CK_N,
      output             HPS_DDR3_CK_P,
      output             HPS_DDR3_CS_N,
      output      [3:0]  HPS_DDR3_DM,
      inout       [31:0] HPS_DDR3_DQ,
      inout       [3:0]  HPS_DDR3_DQS_N,
      inout       [3:0]  HPS_DDR3_DQS_P,
      output             HPS_DDR3_ODT,
      output             HPS_DDR3_RAS_N,
      output             HPS_DDR3_RESET_N,
      input              HPS_DDR3_RZQ,
      output             HPS_DDR3_WE_N,
      output             HPS_ENET_GTX_CLK,
      inout              HPS_ENET_INT_N,
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input       [3:0]  HPS_ENET_RX_DATA,
      input              HPS_ENET_RX_DV,
      output      [3:0]  HPS_ENET_TX_DATA,
      output             HPS_ENET_TX_EN,
      inout              HPS_GSENSOR_INT,
      inout              HPS_I2C0_SCLK,
      inout              HPS_I2C0_SDAT,
      inout              HPS_I2C1_SCLK,
      inout              HPS_I2C1_SDAT,
      inout              HPS_KEY,
      inout              HPS_LED,
      inout              HPS_LTC_GPIO,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout       [3:0]  HPS_SD_DATA,
      output             HPS_SPIM_CLK,
      input              HPS_SPIM_MISO,
      output             HPS_SPIM_MOSI,
      inout              HPS_SPIM_SS,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLKOUT,
      inout       [7:0]  HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// KEY /////////
      input       [1:0]  KEY,

      ///////// LED /////////
      output      [7:0]  LED,

      ///////// SW /////////
      input       [3:0]  SW,

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);

//=======================================================
//  REG/WIRE declarations
//======================================================
   wire       RESET_N ; 
   wire [7:0] BCD_T , BCD_H;  
   wire [7:0] INT_FLAG	 ; 
   
   wire [15:0] DATA0  ; //Ambient Light Sensor DATA ,Channel 0
   wire [15:0] DATA1  ; //Ambient Light Sensor DATA ,Channel 1
   wire [15:0] PS_DATA ;// Proximity Sensor DATA,	
   wire [15:0] IR_DATA ;//	IR sensor data
	
   wire        HM_TR ;
	wire [15:0] HM_XOUT;
	wire [15:0] HM_YOUT;
	wire [15:0] HM_ZOUT;	
 	wire [15:0] ACCEL_XOUT;
	wire [15:0] ACCEL_YOUT;
	wire [15:0] ACCEL_ZOUT;
	wire [15:0] TEMP_OUT;
	wire [15:0] GYRO_XOUT;
	wire [15:0] GYRO_YOUT;
	wire [15:0] GYRO_ZOUT;
	wire [7:0 ] INT_STATUS;  
//=======================================================
//  Structural coding
//=======================================================


//---- RESET ---
assign RESET_N =KEY[0];
//----Humidity -Temperature SENSOR ---	
HC1000 HC1000_i(
      .RESET_N        (RESET_N        ),
      .CLOCK_50       (FPGA_CLK1_50  ),
      .RH_TEMP_DRDY_n (RH_TEMP_DRDY_n ),
      .RH_TEMP_I2C_SCL(RH_TEMP_I2C_SCL), 
      .RH_TEMP_I2C_SDA(RH_TEMP_I2C_SDA),
      .BCD_T          (BCD_T), 
      .BCD_H          (BCD_H)
);		
	
//----Ambient Light Sensor and Proximity Sensor ---	
APM_16D24 APM_16D24_i( 
   //--SYSTEM--   
	.RESET_N  (RESET_N),
   .CLK_50   (FPGA_CLK1_50),
	//--IC SIDE-- 
	.I2C_SCL  (LSENSOR_SCL),
	.I2C_SDA  (LSENSOR_SDA), 
	.CH0_DATA (DATA0 ),
	.CH1_DATA (DATA1 ),
	.PS_DATA  (PS_DATA),
	.IR_DATA  (IR_DATA),
   .INT_FLAG (INT_FLAG) 
	);


//---- RESET ---
	
assign MPU_AD0_SDO =0;
assign MPU_CS_n    =1; 
assign MPU_FSYNC   =0; 
//----9-Axis MEMS MotionTracking ---	
ICM20948  ICM20948_i( 
   //--SYSTEM-- 
	.RESET_N 	 ( RESET_N ),
   .CLK_50      ( FPGA_CLK1_50 ),
	//--IC SIDE--
	.RDY_n       ( MPU_INT),   
	.I2C_SCL     ( MPU_SCL_SCLK),
	.I2C_SDA     ( MPU_SDA_SDI ),
	.ACCEL_XOUT  (ACCEL_XOUT),
	.ACCEL_YOUT  (ACCEL_YOUT),
	.ACCEL_ZOUT  (ACCEL_ZOUT),
	.TEMP_OUT    (TEMP_OUT  ),
	.GYRO_XOUT   (GYRO_XOUT ),
	.GYRO_YOUT   (GYRO_YOUT ),
	.GYRO_ZOUT   (GYRO_ZOUT ),
	.INT_STATUS  (INT_STATUS ),
	.HM_XOUT     (HM_XOUT),
	.HM_YOUT     (HM_YOUT),
	.HM_ZOUT     (HM_ZOUT),
	.TR          (HM_TR) ,	
	
	);


//----------------VIEW -------
//sw:0  HUMITY-TEMP       
//sw:1  Ambient LIGHT SENSOR ADC0 (DATA0)
//sw:2  Ambient LIGHT SENSOR ADC1 (DATA1)
//sw:3  Proximity Sensor DATA	
//sw:4  IR sensor data
//sw:5  THREE-AXIS MEMS ACCELEROMETER X
//sw:6  THREE-AXIS MEMS ACCELEROMETER Y
//sw:7  THREE-AXIS MEMS ACCELEROMETER Z
//sw:8  THREE-AXIS MEMS GYROSCOPE     X
//sw:9  THREE-AXIS MEMS GYROSCOPE     Y
//sw:10 THREE-AXIS MEMS GYROSCOPE     Z
//sw:11 THREE-AXIS MEMS MAGNETOMETER  X
//sw:12 THREE-AXIS MEMS MAGNETOMETER  Y
//sw:13 THREE-AXIS MEMS MAGNETOMETER  Z
//---------------------------------
//-----SENSOR_OUT ---- 
SENSOR_OUT SENSOR_OUT_i(
	.Temperature    ( BCD_T  ),
   .HUMITY         ( BCD_H  ),
	.Ambient_LIGHT0 ( DATA0  ),
	.Ambient_LIGHT1 ( DATA1),
	.Proximity      ( PS_DATA ),
	.IR             ( IR_DATA ),
 	.ACCELEROMETER_X( ACCEL_XOUT),
	.ACCELEROMETER_Y( ACCEL_YOUT),
	.ACCELEROMETER_Z( ACCEL_ZOUT),
	.GYROSCOPE_X    ( GYRO_XOUT ),
	.GYROSCOPE_Y    ( GYRO_YOUT ),
	.GYROSCOPE_Z    ( GYRO_ZOUT ),
	.MAGNETOMETER_X ( HM_XOUT   ),
	.MAGNETOMETER_Y ( HM_YOUT   ),
	.MAGNETOMETER_Z ( HM_ZOUT   ),	
	.RH_TEMP_DRDY_n ( RH_TEMP_DRDY_n),
	.POR            ( INT_FLAG[7]   ), 
	.HM_TR          ( HM_TR         )
); 

//--LED Dispaly 
assign LED[0]= RH_TEMP_DRDY_n;
assign LED[1]= INT_FLAG[7]   ;
assign LED[2]= HM_TR         ;


//---50MHZ LED TEST
CLOCKMEM CLOCKMEM_i(  .CLK(FPGA_CLK1_50) ,.CLK_FREQ(50_000_000), .CK_1HZ (LED[7] ) ) ;

endmodule



