

module UART_RX
#(
parameter ClkFrequency = 28_800_000, 
parameter Baud         = 115200
)
(
   input            rst_n,
   input            clk, 
   input            RxD,
   output           RxD_data_ready,   // onc clock pulse when RxD_data is valid
   output     [7:0] RxD_data,
   output       reg RxD_endofpacket,  // one clock pulse, when no more data is received (RxD_idle is going high)
	output           Baud8Tick , 
   output           RxD_idle          // no data is being received                                                        
);

//--baud rate generator
BAUD_GEN BAUD_GEN_i(
    .rst_n       (rst_n),
    .clk_i       ( clk      ),  
    .tr          ( RxD      ) , 
    .baud_tick   ( Baud8Tick), 
    .baud_freq_i ( Baud     ),
    .baud_limit_i( Baud*(ClkFrequency/Baud) )
);

//--rx 
UART_RX_J UART_RX_J_i(
    .CLK           ( clk      ),
    .RST_N         ( rst_n        ),
    .TICK          ( Baud8Tick),
    .RX            ( RxD      ),
    .oRX_DATA      ( RxD_data ),
    .RxD_data_ready(RxD_data_ready)
  
);

endmodule
