module UART_TX
#(
parameter ClkFrequency = 28800000,
parameter Baud         = 115200
)

(
input       clk     , 
input       rst_n     , 
input       TxD_start,
input [7:0] TxD_data,
output      TxD, 
output      TxD_busy,
output      BaudTick,
output      TX_check_ok
);

UART_TX_J  
#(
.ClkFrequency  ( ClkFrequency), 
.Baud          ( Baud        )
)
UART_TX_J_i(
.SYS_CLK       ( clk        ),
.reset_n       ( rst_n      ),
.start         ( TxD_start  ),
.check_ok      ( TX_check_ok),
.busy          ( TxD_busy   ),
.tick          ( BaudTick   ),
.writedata     ( TxD_data   ),
.tx            ( TxD        )
);


endmodule