module  UART_TX_J
#(
parameter ClkFrequency = 28800000, 
parameter Baud         = 115200
)

 (
input          clk_50  ,
input          SYS_CLK ,
input          reset_n ,
input          start   ,
output         reg check_ok   ,


input          write  ,
input          chipselect,
input [7:0]    writedata ,
output reg     tx ,
output         tick,
output reg[31:0]tick_cnt , 
output reg[7:0]cnt,
output reg[7:0]st,
output reg[7:0]w_data,
output         CK_28M8 ,
output         CK_100M ,

output reg     busy ,
input          SWRATE_115_5M  //1:115200 , 0:5M 
);

   wire         aclr;
	wire  [7:0]  data;	
	wire         rdclk;
	reg          rdreq;
	wire         wrclk;
	wire         wrreq;
	wire	[7:0]  q;
	wire	       rdempty;
	wire	[7:0]  rdusedw;
	wire	       wrfull;
	wire	[7:0]  wrusedw;

	 
	
	
//-- TICK Generator 
assign tick = (tick_cnt==1); 
always @(negedge busy  or posedge  SYS_CLK   ) 
     if  ( !busy)                                 tick_cnt<=0;  
else if  ( tick_cnt>= ( (ClkFrequency/Baud)-1 ))  tick_cnt<=0;  
else tick_cnt<=tick_cnt+1; 

//-- FIFO Controller
always @( negedge reset_n  or posedge SYS_CLK ) begin 
if (!reset_n) begin
  st      <=0;
  cnt     <=10;
  tx      <=1; 
  check_ok<=0 ;
  busy    <=0;

end 
else case(st)
0: st    <=10 ;
1: begin 
   if(tick) begin 
    case(cnt)
	  10:begin tx <=0 ; check_ok<=1; end 
	   9:begin tx <=w_data[0] ;check_ok<=0; end 
	   8:tx <=w_data[1] ;
	   7:tx <=w_data[2] ;
	   6:tx <=w_data[3] ;
	   5:tx <=w_data[4] ;
	   4:tx <=w_data[5] ;
	   3:tx <=w_data[6] ;
	   2:tx <=w_data[7] ;
	   1:begin tx <=1 ; end 
	 endcase
	 if (cnt==1) st<=10 ; else cnt<=cnt-1 ; 
  end
  end 
10: begin st   <= 11; busy <=0 ;end 
11: begin 
//if ( wrusedw !=0) 
if ( start)  begin  cnt <= 10; busy <=1 ; st <= 1;  w_data <=writedata ; end //11;
end   

//11: st   <= 12;

//12: begin 
//    st     <= 13;
//    rdreq  <= 1;
//end   
//13: begin 
//    st     <= 14;
//    rdreq  <= 0;
//end   
//14:begin 
//    st     <= 1;
//    w_data <= q;
//    cnt    <= 10;
//end   
endcase 
end

//--FiFo-- 
//assign wrclk = clk_50;  //importnat
//assign wrreq = write ;  
//assign rdclk = SYS_CLK ;// CK_28M8; //important 
//
//UART_FIFO UART_FIFO_i(
//	.aclr    (~locked | ~reset_n),
//	.rdclk   (rdclk ),
//	.rdreq   (rdreq ),
//	.q       (q     ),
//	.rdempty (rdempty),
//	.rdusedw (),
//	.data    (writedata),	
//	.wrclk   (wrclk ),
//	.wrreq   (wrreq ),	
//	.wrfull  (),
//	.wrusedw (wrusedw)
//	);
//





endmodule 