// ============================================================================
// Copyright (c) 2021 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Jul  7 15:11:40 2021
// ============================================================================

//`define ENABLE_HPS

module DE10_Nano_golden_top(

      ///////// ADC /////////
      output             ADC_CONVST,
      output             ADC_SCK,
      output             ADC_SDI,
      input              ADC_SDO,

      ///////// ARDUINO /////////
      inout       [15:0] ARDUINO_IO,
      inout              ARDUINO_RESET_N,

      ///////// FPGA /////////
      input              FPGA_CLK1_50,
      input              FPGA_CLK2_50,
      input              FPGA_CLK3_50,

      ///////// GPIO /////////
      //inout       [35:0] GPIO_0,
      inout       [35:0] GPIO_1,

      ///////// HDMI /////////
      inout              HDMI_I2C_SCL,
      inout              HDMI_I2C_SDA,
      inout              HDMI_I2S,
      inout              HDMI_LRCLK,
      inout              HDMI_MCLK,
      inout              HDMI_SCLK,
      output             HDMI_TX_CLK,
      output      [23:0] HDMI_TX_D,
      output             HDMI_TX_DE,
      output             HDMI_TX_HS,
      input              HDMI_TX_INT,
      output             HDMI_TX_VS,

`ifdef ENABLE_HPS
      ///////// HPS /////////
      inout              HPS_CONV_USB_N,
      output      [14:0] HPS_DDR3_ADDR,
      output      [2:0]  HPS_DDR3_BA,
      output             HPS_DDR3_CAS_N,
      output             HPS_DDR3_CKE,
      output             HPS_DDR3_CK_N,
      output             HPS_DDR3_CK_P,
      output             HPS_DDR3_CS_N,
      output      [3:0]  HPS_DDR3_DM,
      inout       [31:0] HPS_DDR3_DQ,
      inout       [3:0]  HPS_DDR3_DQS_N,
      inout       [3:0]  HPS_DDR3_DQS_P,
      output             HPS_DDR3_ODT,
      output             HPS_DDR3_RAS_N,
      output             HPS_DDR3_RESET_N,
      input              HPS_DDR3_RZQ,
      output             HPS_DDR3_WE_N,
      output             HPS_ENET_GTX_CLK,
      inout              HPS_ENET_INT_N,
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input       [3:0]  HPS_ENET_RX_DATA,
      input              HPS_ENET_RX_DV,
      output      [3:0]  HPS_ENET_TX_DATA,
      output             HPS_ENET_TX_EN,
      inout              HPS_GSENSOR_INT,
      inout              HPS_I2C0_SCLK,
      inout              HPS_I2C0_SDAT,
      inout              HPS_I2C1_SCLK,
      inout              HPS_I2C1_SDAT,
      inout              HPS_KEY,
      inout              HPS_LED,
      inout              HPS_LTC_GPIO,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout       [3:0]  HPS_SD_DATA,
      output             HPS_SPIM_CLK,
      input              HPS_SPIM_MISO,
      output             HPS_SPIM_MOSI,
      inout              HPS_SPIM_SS,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLKOUT,
      inout       [7:0]  HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// KEY /////////
      input       [1:0]  KEY,

      ///////// LED /////////
      output      [7:0]  LED,

      ///////// SW /////////
      input       [3:0]  SW,

	//////////// GPIO_0, GPIO connect to RFS2 - RF and Sensor //////////
	inout 		          		BT_KEY, //reserved for future use
	input 		          		BT_UART_CTS, //reserved for future use
	output		          		BT_UART_RTS, //reserved for future use
	input 		          		BT_UART_RX, //reserved for future use
	output		          		BT_UART_TX, //reserved for future use
	output		          		ESP32_EN,
	input 		          		ESP32_UART0_RX,
	output		          		ESP32_UART0_TX,
	input 		          		ESP32_UART1_CTS,
	output		          		ESP32_UART1_RTS,
	input 		          		ESP32_UART1_RX,
	output		          		ESP32_UART1_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RX,
	output		          		UART_TX
);



//=======================================================
//  REG/WIRE declarations
//=======================================================
wire		      DLY_RST;
wire [23:0]	   mSEG7_DIG;
wire           UART_RXD_TXD ; 
wire           ADDRESS  ;
wire           CS       ;
wire [3:0]     BYTE_ENABLE     ;
wire           READ     ;
wire           WRITE    ;
wire           IRQ      ;
wire [31:0]    WRITEDATA;
wire [31:0]    READDATA ;
wire           READY ;
wire           UART_RX_1 ; 
wire [7:0]     Second;
wire [7:0]     Minute ;
wire [7:0]     Hour   ;
wire [7:0]     MESSAGE;
wire [159: 0 ] NAME; 
wire [159: 0 ] PASSWORD; 
wire [159: 0 ] oNAME; 
wire [159: 0 ] oPASSWORD; 
wire [7: 0 ]   NAME_LN     ;
wire [7: 0 ]   PASSWORD_LN ;

//=======================================================
//  Structural coding
//=======================================================
// initial // 
//assign HEX6=7'h7f ;
//assign HEX7=7'h7f ;

assign ESP32_UART1_RTS  = 0;//WIFI_UART0_CTS;// 0;
assign ESP32_EN         =  (DLY_EN)?1'bz:1'b0;



//---- RESET DELAY  ---	
Reset_Delay	 r0	(	
      .iRESET_N  ( KEY [0]     )  , 
		.iCLK      ( FPGA_CLK1_50),
		.oRESET1   ( DLY_EN   ),//1s				
		.oRESET2   ( DLY_RST  )	//3s	
	);	
//---- FROM ESP32-WROOM-32E RX  ---	
assign UART_RX_1  = READY ? ESP32_UART1_RX :1  ;

//--- NAME & PASSWORD    
assign NAME      = "" ; 
assign PASSWORD  = "";

//--- NAME & PASSWORD String Check  
 NAME_PASSWD  cf( 
   .CLK        ( FPGA_CLK1_50  ) ,
   .RESET_N    ( KEY [0]  ), 
   .NAME       ( NAME     ), 
   .PASSWORD   ( PASSWORD ),
   .NAME_LN    ( NAME_LN  ),
   .PASSWORD_LN( PASSWORD_LN ),
   .oNAME      ( oNAME     ),
   .oPASSWORD  ( oPASSWORD )
) ; 

//-- WIFI COMMAND SEQUENCE CONTROLLER -- 
UART_ST   st    (
   .CLK         (FPGA_CLK1_50 ),
	.NAME        ( oNAME       ) , 
   .PASSWORD    ( oPASSWORD),
   .NAME_LN     ( NAME_LN ), 
   .PASSWORD_LN ( PASSWORD_LN ),	
   .RX          ( UART_RX_1), 	
   .RESET_N     ( DLY_RST  ) ,

   //--UART IP BUS 
   .ADDRESS     ( ADDRESS  ) ,
   .CS          ( CS       ) ,
   .BYTE_ENABLE ( BYTE_ENABLE ),
   .READ        ( READ     ),
   .WRITE       ( WRITE    ),
   .WRITEDATA   ( WRITEDATA ),
   .READDATA    ( READDATA ),
	.READY       ( READY ) ,
	.MESSAGE     ( MESSAGE ),

//----ESP32-WROOM-32E FROM UART RESPONSE WIFI CLOCK ---
   .Second      ( Second ),
   .Minute      ( Minute ),  
   .Hour        ( Hour   )
);

//----TX
UART_TX   UART_TX_i(
   .clk_50      ( FPGA_CLK1_50),
   .reset_n     ( DLY_RST & READY),
   .write       ( WRITE),
   .chipselect  ( CS),
   .writedata   ( WRITEDATA),
   .tx          ( ESP32_UART1_TX)
);

							
//---- LED DISPLAY  ---
assign  LED[7:0]    = { READY ,ESP32_UART1_RX, ESP32_UART1_TX, MESSAGE[3:0] } ;


endmodule

